// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'acHTTPDownloadQueue.pas' rev: 4.00

#ifndef acHTTPDownloadQueueHPP
#define acHTTPDownloadQueueHPP

#pragma delphiheader begin
#pragma option push -w-
#include <SimpleXML.hpp>	// Pascal unit
#include <acHTTP.hpp>	// Pascal unit
#include <acThread.hpp>	// Pascal unit
#include <acClasses.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Achttpdownloadqueue
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TacFileStatus { fsUnknown, fsNotExists, fsComplete, fsIncomplete };
#pragma option pop

class DELPHICLASS TacDownloadQueueItemLink;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacDownloadQueueItemLink : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	void *Data;
	Classes::TNotifyEvent OnBeforeQueueItemDestruction;
	__fastcall TacDownloadQueueItemLink(void * AData, Classes::TNotifyEvent ABeforeQueueItemDestruction
		);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TacDownloadQueueItemLink(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TacDownloadQueueItemLinkList;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacDownloadQueueItemLinkList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	HIDESBASE TacDownloadQueueItemLink* __fastcall Get(int Index);
	HIDESBASE void __fastcall Put(int Index, TacDownloadQueueItemLink* Item);
	
public:
	TacDownloadQueueItemLink* __fastcall AddLink(void * Data, Classes::TNotifyEvent BeforeQueueItemDestructionMethod
		);
	void __fastcall RemoveLink(void * Data);
	__property TacDownloadQueueItemLink* Items[int Index] = {read=Get, write=Put/*, default*/};
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TacDownloadQueueItemLinkList(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TacDownloadQueueItemLinkList(void) : Classes::TList() { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma option push -b-
enum TacDownloadQueuePriority { qipPaused, qipLowest, qipLow, qipNormal, qipHigh, qipHighest };
#pragma option pop

class DELPHICLASS TacDownloadQueueItem;
class DELPHICLASS TacHTTPDownloadQueue;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacDownloadQueueItem : public Acclasses::TacCollectionDataItem 
{
	typedef Acclasses::TacCollectionDataItem inherited;
	
private:
	AnsiString FTargetFileName;
	AnsiString FTempFileName;
	AnsiString FURL;
	TacDownloadQueuePriority FPriority;
	int FResumeCount;
	int FSizeTotal;
	int FSizeReceived;
	int FPreSizeReceived;
	Achttp::TacHTTPPragmaNoCache* FHTTP;
	TacDownloadQueueItemLinkList* FLinks;
	AnsiString __fastcall GetTempFileName();
	bool __fastcall GetBusy(void);
	AnsiString __fastcall GetServer();
	int __fastcall GetElapsedTime(void);
	int __fastcall GetEstimatedTime(void);
	float __fastcall GetTransferRate(void);
	int __fastcall GetProgress(void);
	TacHTTPDownloadQueue* __fastcall GetDownloadQueue(void);
	TacFileStatus __fastcall GetStatus(void);
	
protected:
	virtual AnsiString __fastcall GetDisplayName();
	
public:
	__fastcall virtual TacDownloadQueueItem(Classes::TCollection* Collection);
	__fastcall virtual ~TacDownloadQueueItem(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Start(void);
	void __fastcall Pause(void);
	void __fastcall Abort(bool DeleteFile);
	void __fastcall RemoveFromQueue(void);
	void __fastcall SaveDataToStream(Classes::TStream* Stream);
	void __fastcall LoadDataToStream(Classes::TStream* Stream);
	__property Achttp::TacHTTPPragmaNoCache* HTTP = {read=FHTTP};
	__property AnsiString Server = {read=GetServer, stored=false};
	__property TacHTTPDownloadQueue* DownloadQueue = {read=GetDownloadQueue};
	__property TacDownloadQueueItemLinkList* Links = {read=FLinks};
	__property TacFileStatus Status = {read=GetStatus, nodefault};
	__property int PreSizeReceived = {read=FPreSizeReceived, stored=false, nodefault};
	
__published:
	__property AnsiString TargetFileName = {read=FTargetFileName, write=FTargetFileName};
	__property AnsiString TempFileName = {read=GetTempFileName, write=FTempFileName};
	__property AnsiString URL = {read=FURL, write=FURL};
	__property TacDownloadQueuePriority Priority = {read=FPriority, write=FPriority, default=3};
	__property bool Busy = {read=GetBusy, write=SetNoneBool, stored=false, nodefault};
	__property int SizeTotal = {read=FSizeTotal, write=SetNoneInt, stored=false, nodefault};
	__property int SizeReceived = {read=FSizeReceived, write=FSizeReceived, stored=false, nodefault};
	__property int ElapsedTime = {read=GetElapsedTime, write=SetNoneInt, stored=false, nodefault};
	__property int EstimatedTime = {read=GetEstimatedTime, write=SetNoneInt, stored=false, nodefault};
	__property int Progress = {read=GetProgress, write=SetNoneInt, stored=false, nodefault};
	__property int ResumeCount = {read=FResumeCount, write=SetNoneInt, stored=false, nodefault};
	__property float TransferRate = {read=GetTransferRate, write=SetNoneFloat, stored=false};
};

#pragma pack(pop)

class DELPHICLASS TacDownloadQueueCollection;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacDownloadQueueCollection : public Classes::TOwnedCollection 
{
	typedef Classes::TOwnedCollection inherited;
	
private:
	HIDESBASE TacDownloadQueueItem* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, TacDownloadQueueItem* Value);
	
public:
	HIDESBASE TacDownloadQueueItem* __fastcall Add(void);
	void __fastcall Delete(int Index);
	HIDESBASE void __fastcall Clear(bool DontClearRunningItems, bool StopRunningItems);
	__property TacDownloadQueueItem* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
public:
		
	#pragma option push -w-inl
	/* TOwnedCollection.Create */ inline __fastcall TacDownloadQueueCollection(Classes::TPersistent* AOwner
		, TMetaClass* ItemClass) : Classes::TOwnedCollection(AOwner, ItemClass) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TacDownloadQueueCollection(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TacDownloadQueueLimits;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacDownloadQueueLimits : public Acclasses::TacPersistent 
{
	typedef Acclasses::TacPersistent inherited;
	
private:
	int FMaxDownloads;
	int FMaxFrom1Server;
	int FMaxSpeedKbps;
	bool FDontObeySpeedLimitOnScreenSaverActive;
	
public:
	__fastcall virtual TacDownloadQueueLimits(Classes::TComponent* aOwner);
	
__published:
	__property int MaxDownloads = {read=FMaxDownloads, write=FMaxDownloads, default=4};
	__property int MaxFrom1Server = {read=FMaxFrom1Server, write=FMaxFrom1Server, default=2};
	__property int MaxSpeedKbps = {read=FMaxSpeedKbps, write=FMaxSpeedKbps, default=0};
	__property bool DontObeySpeedLimitOnScreenSaverActive = {read=FDontObeySpeedLimitOnScreenSaverActive
		, write=FDontObeySpeedLimitOnScreenSaverActive, default=1};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TacDownloadQueueLimits(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TacDownloadQueueOutputFileAttributes;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacDownloadQueueOutputFileAttributes : public Achttp::TacOutputFileAttributes 
	
{
	typedef Achttp::TacOutputFileAttributes inherited;
	
protected:
	DYNAMIC void __fastcall AttributesChanged(void);
public:
	#pragma option push -w-inl
	/* TacOutputFileAttributes.Create */ inline __fastcall virtual TacDownloadQueueOutputFileAttributes
		(Classes::TComponent* aOwner) : Achttp::TacOutputFileAttributes(aOwner) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TacDownloadQueueOutputFileAttributes(void) { }
		
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TacDownloadQueueTempFiles;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacDownloadQueueTempFiles : public Acclasses::TacPersistent 
{
	typedef Acclasses::TacPersistent inherited;
	
private:
	bool FCreateTempFiles;
	AnsiString FTempFolder;
	AnsiString FTempFileExt;
	Byte FTempFileSaltLength;
	
public:
	__fastcall virtual TacDownloadQueueTempFiles(Classes::TComponent* aOwner);
	
__published:
	__property bool CreateTempFiles = {read=FCreateTempFiles, write=FCreateTempFiles, default=0};
	__property AnsiString TempFolder = {read=FTempFolder, write=FTempFolder};
	__property AnsiString TempFileExt = {read=FTempFileExt, write=FTempFileExt};
	__property Byte TempFileSaltLength = {read=FTempFileSaltLength, write=FTempFileSaltLength, default=8
		};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TacDownloadQueueTempFiles(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

typedef void __fastcall (__closure *TacDownloadQueueAlreadyDownloadedEvent)(System::TObject* Sender, 
	const AnsiString FileName);

typedef void __fastcall (__closure *TacDownloadQueueProgressEvent)(System::TObject* Sender, TacDownloadQueueItem* 
	Item, const AnsiString ContentType, int DataSize, int BytesRead, int ElapsedTime, int EstimatedTimeLeft
	, Byte PercentsDone, float TransferRate, Classes::TStream* Stream);

typedef void __fastcall (__closure *TacDownloadQueueContentLengthFixEvent)(System::TObject* Sender, 
	TacDownloadQueueItem* Item, int ErrorCode, int ContentLength);

typedef void __fastcall (__closure *TacDownloadQueueHeaderInfoEvent)(System::TObject* Sender, TacDownloadQueueItem* 
	Item, int ErrorCode, const AnsiString RawHeadersCRLF, const AnsiString ContentType, const AnsiString 
	ContentLanguage, const AnsiString ContentEncoding, int ContentLength, const AnsiString Location, const 
	System::TDateTime Date, const System::TDateTime LastModified, const System::TDateTime Expires, const 
	AnsiString ETag, bool &ContinueDownload);

typedef void __fastcall (__closure *TacDownloadQueueRedirected)(System::TObject* Sender, TacDownloadQueueItem* 
	Item, const AnsiString NewURL);

typedef void __fastcall (__closure *TacDownloadQueueDoneEvent)(System::TObject* Sender, TacDownloadQueueItem* 
	Item, const AnsiString ContentType, int FileSize, Classes::TStream* Stream);

typedef void __fastcall (__closure *TacDownloadQueueConnLostEvent)(System::TObject* Sender, TacDownloadQueueItem* 
	Item, const AnsiString ContentType, int FileSize, int BytesRead, Classes::TStream* Stream);

typedef void __fastcall (__closure *TacDownloadQueueErrorEvent)(System::TObject* Sender, TacDownloadQueueItem* 
	Item, int ErrorCode, Classes::TStream* Stream);

typedef void __fastcall (__closure *TacDownloadQueuePasswordRequestEvent)(System::TObject* Sender, TacDownloadQueueItem* 
	Item, const AnsiString Realm, bool &TryAgain);

typedef void __fastcall (__closure *TacDownloadQueueProxyAuthenticationEvent)(System::TObject* Sender
	, TacDownloadQueueItem* Item, AnsiString &ProxyUsername, AnsiString &ProxyPassword, bool &TryAgain)
	;

typedef void __fastcall (__closure *TacDownloadQueueNotifyEvent)(System::TObject* Sender, TacDownloadQueueItem* 
	Item);

typedef void __fastcall (__closure *TacDownloadQueueBusySlotsChangeEvent)(System::TObject* Sender, int 
	BusySlots);

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TacHTTPDownloadQueue : public Acclasses::TacComponent 
{
	typedef Acclasses::TacComponent inherited;
	
private:
	bool FAutoCreateFolders;
	bool FAutoDownload;
	TacDownloadQueueOutputFileAttributes* FFileAttributes;
	AnsiString FTargetFolder;
	TacDownloadQueueLimits* FLimits;
	TacDownloadQueueTempFiles* FTempFiles;
	TacDownloadQueueCollection* FQueue;
	Acclasses::TacXMLStorageFile* FQueueFile;
	Classes::TStrings* FAddHeaders;
	AnsiString FAcceptTypes;
	AnsiString FAgent;
	Achttp::TacHTTPProxy* FProxy;
	Classes::TThreadPriority FThreadPriority;
	Achttp::TacHTTPTimeouts* FTimeouts;
	Achttp::TacBufferSize FTransferBufferSize;
	int FBusySlots;
	bool FRandomized;
	TacDownloadQueueHeaderInfoEvent FOnHTTPHeaderInfo;
	TacDownloadQueueDoneEvent FOnHTTPDone;
	TacDownloadQueueNotifyEvent FOnHTTPDoneInterrupted;
	TacDownloadQueueProgressEvent FOnHTTPProgress;
	TacDownloadQueueRedirected FOnHTTPRedirected;
	TacDownloadQueueNotifyEvent FOnHTTPAnyError;
	TacDownloadQueueNotifyEvent FOnHTTPAborted;
	TacDownloadQueueConnLostEvent FOnHTTPConnLost;
	TacDownloadQueueNotifyEvent FOnHTTPHostUnreachable;
	TacDownloadQueueErrorEvent FOnHTTPError;
	TacDownloadQueuePasswordRequestEvent FOnHTTPPasswordRequest;
	TacDownloadQueueProxyAuthenticationEvent FOnHTTPProxyAuthenticationRequest;
	TacDownloadQueueNotifyEvent FOnHTTPOutputFileError;
	TacDownloadQueueAlreadyDownloadedEvent FOnAlreadyDownloaded;
	TacDownloadQueueBusySlotsChangeEvent FOnBusySlotsChange;
	TacDownloadQueueNotifyEvent FOnQueueItemAdded;
	TacDownloadQueueNotifyEvent FOnQueueItemRemoved;
	void __fastcall SetAddHeaders(Classes::TStrings* Value);
	void __fastcall SetThreadPriority(Classes::TThreadPriority Value);
	void __fastcall SetAutoDownload(bool Value);
	void __fastcall SetBusySlots(int Value);
	void __fastcall HTTPHeaderInfo(System::TObject* Sender, int ErrorCode, const AnsiString RawHeadersCRLF
		, const AnsiString ContentType, const AnsiString ContentLanguage, const AnsiString ContentEncoding
		, int ContentLength, const AnsiString Location, const System::TDateTime Date, const System::TDateTime 
		LastModified, const System::TDateTime Expires, const AnsiString ETag, bool &ContinueDownload);
	void __fastcall HTTPDone(System::TObject* Sender, const AnsiString ContentType, int FileSize, Classes::TStream* 
		Stream);
	void __fastcall HTTPDoneInterrupted(System::TObject* Sender);
	void __fastcall HTTPProgress(System::TObject* Sender, const AnsiString ContentType, int DataSize, int 
		BytesRead, int ElapsedTime, int EstimatedTimeLeft, Byte PercentsDone, float TransferRate, Classes::TStream* 
		Stream);
	void __fastcall HTTPRedirected(System::TObject* Sender, const AnsiString NewURL);
	void __fastcall HTTPAnyError(System::TObject* Sender);
	void __fastcall HTTPAborted(System::TObject* Sender);
	void __fastcall HTTPConnLost(System::TObject* Sender, const AnsiString ContentType, int FileSize, int 
		BytesRead, Classes::TStream* Stream);
	void __fastcall HTTPHostUnreachable(System::TObject* Sender);
	void __fastcall HTTPHTTPError(System::TObject* Sender, int ErrorCode, Classes::TStream* Stream);
	void __fastcall HTTPOutputFileError(System::TObject* Sender);
	void __fastcall HTTPPasswordRequest(System::TObject* Sender, const AnsiString Realm, bool &TryAgain
		);
	void __fastcall HTTPProxyAuthenticationRequest(System::TObject* Sender, AnsiString &ProxyUsername, 
		AnsiString &ProxyPassword, bool &TryAgain);
	
protected:
	TacDownloadQueueContentLengthFixEvent FOnInternalHTTPHeaderInfo;
	virtual void __fastcall Loaded(void);
	TacFileStatus __fastcall GetTargetFileStatus(const AnsiString TargetFileName, __int64 &FileSize)/* overload */
		;
	TacFileStatus __fastcall GetTargetFileStatus(const AnsiString TargetFileName)/* overload */;
	void __fastcall GenerateFileNamesByURL(const AnsiString URL, AnsiString &TargetFileName, AnsiString 
		&TempFileName);
	AnsiString __fastcall GenerateSaltStr(Byte SaltLength);
	TacDownloadQueueItem* __fastcall QueueItemByHTTP(System::TObject* HTTPObject);
	void __fastcall ProcessAutoDownloads(void);
	__property int BusySlots = {read=FBusySlots, write=SetBusySlots, nodefault};
	
public:
	__fastcall virtual TacHTTPDownloadQueue(Classes::TComponent* aOwner);
	__fastcall virtual ~TacHTTPDownloadQueue(void);
	TacDownloadQueueItem* __fastcall Download(const AnsiString URL, bool StartImediately, TacDownloadQueuePriority 
		Priority)/* overload */;
	TacDownloadQueueItem* __fastcall Download(const AnsiString URL, AnsiString TargetFileName, AnsiString 
		TempFileName, bool StartImediately, TacDownloadQueuePriority Priority)/* overload */;
	TacDownloadQueueItem* __fastcall Enqueue(const AnsiString URL);
	void __fastcall EnqueueURLs(Classes::TStrings* URLs, TacDownloadQueuePriority Priority)/* overload */
		;
	void __fastcall Pause(const AnsiString URL)/* overload */;
	void __fastcall Pause(TacDownloadQueueItem* QueueItem)/* overload */;
	void __fastcall PauseAll(void);
	void __fastcall Delete(const AnsiString URL)/* overload */;
	void __fastcall Delete(TacDownloadQueueItem* QueueItem)/* overload */;
	void __fastcall Clear(bool DontClearRunningItems, bool StopRunningItems);
	AnsiString __fastcall URLToTargetFileName(const AnsiString URL);
	bool __fastcall IsQueued(const AnsiString URL);
	TacDownloadQueueItem* __fastcall FindQueueItemByURL(const AnsiString URL);
	TacFileStatus __fastcall GetFileStatus(const AnsiString URL, AnsiString ExpectedTargetFileName)/* overload */
		;
	TacFileStatus __fastcall GetFileStatus(TacDownloadQueueItem* QueueItem)/* overload */;
	TacDownloadQueueItem* __fastcall GetFileNameAndStatusByURL(const AnsiString URL, AnsiString &FileName
		, TacFileStatus &FileStatus);
	bool __fastcall IsDownloading(const AnsiString URL)/* overload */;
	bool __fastcall IsDownloading(TacDownloadQueueItem* QueueItem)/* overload */;
	bool __fastcall SaveToFile(const AnsiString FileName);
	bool __fastcall LoadFromFile(const AnsiString FileName, bool ResetQueueList);
	bool __fastcall SaveToStream(Classes::TStream* Stream);
	bool __fastcall LoadFromStream(Classes::TStream* Stream, bool ResetQueueList);
	void __fastcall SaveToXMLDocument(Simplexml::_di_IXmlDocument Document);
	bool __fastcall LoadFromXMLDocument(Simplexml::_di_IXmlDocument Document, bool ResetQueueList);
	void __fastcall SaveDataToStream(Classes::TStream* Stream);
	void __fastcall LoadDataFromStream(Classes::TStream* Stream, bool ResetQueueList);
	void __fastcall SaveQueueFile(void);
	void __fastcall LoadQueueFile(void);
	__property int BusyDownloadSlots = {read=FBusySlots, nodefault};
	
__published:
	__property bool AutoCreateFolders = {read=FAutoCreateFolders, write=FAutoCreateFolders, default=1};
		
	__property bool AutoDownload = {read=FAutoDownload, write=SetAutoDownload, default=1};
	__property TacDownloadQueueOutputFileAttributes* FileAttributes = {read=FFileAttributes, write=FFileAttributes
		};
	__property AnsiString TargetFolder = {read=FTargetFolder, write=FTargetFolder};
	__property TacDownloadQueueLimits* Limits = {read=FLimits, write=FLimits};
	__property TacDownloadQueueTempFiles* TempFiles = {read=FTempFiles, write=FTempFiles};
	__property TacDownloadQueueCollection* Queue = {read=FQueue, write=FQueue, stored=false};
	__property Acclasses::TacXMLStorageFile* QueueFile = {read=FQueueFile, write=FQueueFile};
	__property AnsiString AcceptTypes = {read=FAcceptTypes, write=FAcceptTypes};
	__property Classes::TStrings* AddHeaders = {read=FAddHeaders, write=SetAddHeaders};
	__property AnsiString Agent = {read=FAgent, write=FAgent};
	__property Achttp::TacHTTPProxy* Proxy = {read=FProxy, write=FProxy};
	__property Classes::TThreadPriority ThreadPriority = {read=FThreadPriority, write=SetThreadPriority
		, default=3};
	__property Achttp::TacHTTPTimeouts* Timeouts = {read=FTimeouts, write=FTimeouts};
	__property Achttp::TacBufferSize TransferBufferSize = {read=FTransferBufferSize, write=FTransferBufferSize
		, default=4096};
	__property TacDownloadQueueHeaderInfoEvent OnHTTPHeaderInfo = {read=FOnHTTPHeaderInfo, write=FOnHTTPHeaderInfo
		};
	__property TacDownloadQueueDoneEvent OnHTTPDone = {read=FOnHTTPDone, write=FOnHTTPDone};
	__property TacDownloadQueueProgressEvent OnHTTPProgress = {read=FOnHTTPProgress, write=FOnHTTPProgress
		};
	__property TacDownloadQueueRedirected OnHTTPRedirected = {read=FOnHTTPRedirected, write=FOnHTTPRedirected
		};
	__property TacDownloadQueueNotifyEvent OnHTTPAnyError = {read=FOnHTTPAnyError, write=FOnHTTPAnyError
		};
	__property TacDownloadQueueNotifyEvent OnHTTPAborted = {read=FOnHTTPAborted, write=FOnHTTPAborted};
		
	__property TacDownloadQueueConnLostEvent OnHTTPConnLost = {read=FOnHTTPConnLost, write=FOnHTTPConnLost
		};
	__property TacDownloadQueueNotifyEvent OnHTTPDoneInterrupted = {read=FOnHTTPDoneInterrupted, write=
		FOnHTTPDoneInterrupted};
	__property TacDownloadQueuePasswordRequestEvent OnHTTPPasswordRequest = {read=FOnHTTPPasswordRequest
		, write=FOnHTTPPasswordRequest};
	__property TacDownloadQueueProxyAuthenticationEvent OnHTTPProxyAuthenticationRequest = {read=FOnHTTPProxyAuthenticationRequest
		, write=FOnHTTPProxyAuthenticationRequest};
	__property TacDownloadQueueNotifyEvent OnHTTPOutputFileError = {read=FOnHTTPOutputFileError, write=
		FOnHTTPOutputFileError};
	__property TacDownloadQueueNotifyEvent OnHTTPHostUnreachable = {read=FOnHTTPHostUnreachable, write=
		FOnHTTPHostUnreachable};
	__property TacDownloadQueueErrorEvent OnHTTPError = {read=FOnHTTPError, write=FOnHTTPError};
	__property TacDownloadQueueAlreadyDownloadedEvent OnAlreadyDownloaded = {read=FOnAlreadyDownloaded, 
		write=FOnAlreadyDownloaded};
	__property TacDownloadQueueBusySlotsChangeEvent OnBusySlotsChange = {read=FOnBusySlotsChange, write=
		FOnBusySlotsChange};
	__property TacDownloadQueueNotifyEvent OnQueueItemAdded = {read=FOnQueueItemAdded, write=FOnQueueItemAdded
		};
	__property TacDownloadQueueNotifyEvent OnQueueItemRemoved = {read=FOnQueueItemRemoved, write=FOnQueueItemRemoved
		};
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Achttpdownloadqueue */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Achttpdownloadqueue;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// acHTTPDownloadQueue
